// auctions.as

/* ---------------- INCLUDE LIBRARIES ------------------- */

// #include "XPath.as"
#include "MovieClip_extensions.as"
#include "TextField_extensions.as"
#include "color_extensions.as"
#include "easing.as"
#include "Buttonbox.as"
#include "Boardbox.as"
#include "Answerbox.as"
#include "event_queue.as"

/* ---------------- DECLARATION ------------------- */

// _root variables

_global.jdgButtonHold = false;
var depthCount = 50;
var attachedMcs = [];
var hiddenBoxMcs = [];
var buttonBlinkRate = 500; //ms
var soundPlaying = true;
var swfRoot = _root;
var firstPlay = true;
var mcAnswerIds = ['A. ','B. ','C. ','D. '];
var playerScore = 0;
var winningScore = 1500;
var currentPointValue = 0;
var currentQuestionIsDare = false;
var extendedPlay = false;
var checkExtend = true;
var questionsPlayed = 0;

var pointbase = 100;

var quboxPos = [51,55];

var boxStart = [45, 50];
var boxSpacing = [140, 113];
var catLabelY = 16;

var continueButtonPos = [190, 331];

var questionTextPadding = 24;
var answerTextPadding = 7;

var answerBoxYSpacing = 6;
var answerBoxIndent = 24;

// [normal, rollover, dead]
var bdboxBgColors = [0x8ED8F8,0x8ED8F8,0x3789CC];
var bdboxOlColors = [0x245483,0xFFC20E,0x245483];

// [normal, rollover, dead, correct/selected, incorrect/selected, correct/unselected]
var ansboxBgColors =  [0xFFFFFF,0xFFFFFF,0xFFFFFF,0x5B8F27,0xA4111F,0xFFFFFF];
var ansboxOlColors =  [0xBDCCE9,0x1F4270,0xBFC2D5,0x005CAC,0xBDCCE9,0x5B8F27];
var ansboxTextColors = [0x005CAC,0x005CAC,0xBDCCE9,0xFFFFFF,0xFFFFFF,0x005CAC];

// [normal, rollover, dead]
var contbtnBgColors = [0xFFFFFF,0xFFFFFF,0xFFFFFF];
var contbtnOlColors = [0xBDCCE9,0x005CAC,0xBDCCE9];
var contbtnTextColors = [0x005CAC,0x005CAC,0x005CAC];

// [normal, rollover, dead]
var darebtnBgColors = [0xB72026,0xB72026,0xB72026];
var darebtnOlColors = [0xB72026,0xFFC20E,0xB72026];
var darebtnTextColors = [0xFFFFFF,0xFFFFFF,0xFFFFFF];

// [normal, rollover, dead]
var extendbtnBgColors = [0x8ED8F8,0x8ED8F8,0x3789CC];
var extendbtnOlColors = [0x245483,0xFFC20E,0x245483];
var extendbtnTextColors = [0x245483,0x245483,0x245483];

// [normal, rollover, dead]
var barbtnBgColors = [0x8ED8F8,0x8ED8F8,0x3789CC];
var barbtnOlColors = [0xFFFFFF,0xFFC20E,0xFFFFFF];
var barbtnTextColors = [0xFFFFFF,0xFFFFFF,0xFFFFFF];

var ansboxTf = new TextFormat ();
ansboxTf.align = 'left';
ansboxTf.font = 'f_TheSansBold';
ansboxTf.size = 12;
ansboxTf.color = 0x005CAC;

var ansboxBoolTf = new TextFormat ();
ansboxBoolTf.align = 'center';
ansboxBoolTf.font = 'f_TheSansBold';
ansboxBoolTf.size = 12;
ansboxBoolTf.color = 0x005CAC;

var questionTf = new TextFormat ();
questionTf.align = 'left';
questionTf.font = 'f_TheSansBold';
questionTf.size = 14;
questionTf.color = 0x1F4270;

var explanationCorrectTf= new TextFormat ();
explanationCorrectTf.align = 'left';
explanationCorrectTf.font = 'f_TheSansBold';
explanationCorrectTf.color = 0x5B8F27;
explanationCorrectTf.size = 13;

var explanationIncorrectTf = new TextFormat ();
explanationIncorrectTf.align = 'left';
explanationIncorrectTf.font = 'f_TheSansBold';
explanationIncorrectTf.color = 0xA4111F;
explanationIncorrectTf.size = 13;

var categoryTf = new TextFormat ();
categoryTf.align = 'center';
categoryTf.font = 'f_TheSansBold';
categoryTf.color = 0xFFFFFF;
categoryTf.size = 13;

var scoreLabelTf = new TextFormat ();
scoreLabelTf.align = 'right';
scoreLabelTf.font = 'f_TheSansBold';
scoreLabelTf.color = 0xFFFFFF;
scoreLabelTf.size = 15;

var scoreTextTf = new TextFormat ();
scoreTextTf.align = 'center';
scoreTextTf.font = 'f_TheSansBold';
scoreTextTf.color = 0xFFC20E;
scoreTextTf.size = 26;


/* ---------------- SOUNDS ------------------- */

var queuedSound;
var soundLoadQueue = [];
var soundList = [];
loadQueuedSound = function () {
	if (_root.queuedSound.ambient) {
		_root.queuedSound.start (0,1000);
		_root.queuedSound.playing = true;
	}
	if (_root.soundLoadQueue.length > 0) {
		var qs = _root.soundLoadQueue.pop ();
		_root.queuedSound = qs;
		if (qs.external) {
			qs.onLoad = _root.loadQueuedSound;
			qs.loadSound (qs.sourcename);
		} else {
			qs.attachSound (qs.sourcename);
			_root.loadQueuedSound ();
		}
	}
}

// soundList [id, sourcename, external, looping, ambient]

// soundList.push (['rhythm','snd_lineup_rhythm',false,false,true]);

soundList.push (['blip1', 's_blip1', false, false, false]);
soundList.push (['blip2', 's_blip2', false, false, false]);
soundList.push (['blip3', 's_blip3', false, false, false]);
//soundList.push (['applause', 's_applause', false, false, false]);
//soundList.push (['awww', 's_awww', false, false, false]);
soundLIst.push (['correct', 's_correct', false, false, false]);
soundLIst.push (['incorrect', 's_incorrect', false, false, false]);
soundLIst.push (['question', 's_question', false, false, false]);
soundLIst.push (['banjodouble', 's_banjodouble', false, false, false]);
soundLIst.push (['banjocorrect', 's_banjocorrect', false, false, false]);
soundLIst.push (['banjoincorrect', 's_banjoincorrect', false, false, false]);
soundLIst.push (['ending', 'auctions_ending.mp3', true, false, false]);

for (var i in soundList) {
	_root['sound_' + soundList[i][0]] = new Sound (_root);
	var sRef = _root['sound_' + soundList[i][0]];
	sRef.sourcename = soundList[i][1];
	sRef.external = soundList[i][2];
	sRef.looping = soundList[i][3];
	sRef.ambient = soundList[i][4];
	_root.soundLoadQueue.push (sRef);
	soundList[i] = sRef;
}


/* ---------------- CLASSES ------------------- */

Object.registerClass ('m_smallbtn', Buttonbox);
Object.registerClass ('m_btnExtend', Buttonbox);
Object.registerClass ('m_btnStop', Buttonbox);
Object.registerClass ('m_btnContinue', Buttonbox);
Object.registerClass ('m_btnClose', Buttonbox);
Object.registerClass ('m_btnReplay', Buttonbox);

/* ---------------- FUNCTIONS ------------------- */

newMCDepth = function () {
	return depthCount ++;
}

endWait = function () {
	_level0.i_eventQueue.endWait ();
}

returnRandomArray = function (a) {
	var rand, tempArray = [], rtnArray = [];
	tempArray = tempArray.concat (a);
	while (tempArray.length) {
		rand = Math.floor (Math.random () * tempArray.length);
		rtnArray.push (tempArray[rand]);
		tempArray.splice (rand, 1);
	}
	return rtnArray;
}

startGame = function () {
	if (_root.firstPlay) {
		_root.loadQueuedSound ();
	}
	for (var i in _root.attachedMcs) { _root.attachedMcs[i].removeMovieClip (); }
	_root.attachNewMc (_root, 'm_bgGame', 'i_bgGame');
	_root.showBreaker ();
}

showBreaker = function () {
	_root.attachNewMc (_root, 'm_scr_intro', 'i_scr_intro');
	_root.i_scr_intro._alpha = 0;
	_root.attachNewMc (_root.i_scr_intro, 'm_btnContinue', 'i_btnContinue');
	_root.i_scr_intro.i_btnContinue.moveToA  ([526,443]);
	_root.i_scr_intro.i_btnContinue.bgColors = _root.barbtnBgColors;
	_root.i_scr_intro.i_btnContinue.olColors = _root.barbtnOlColors;
	_root.i_scr_intro.i_btnContinue.textColors = _root.barbtnTextColors;
	_root.i_scr_intro.i_btnContinue.onRelease = function () { _root.endBreaker (); }
	
	_level0.i_eventQueue.addEvent (_root.i_scr_intro, 'tweenTo', [[['_alpha',100]],10], true);
}

endBreaker = function () {
	_level0.i_eventQueue.addEvent (_root.i_scr_intro, 'tweenTo', [[['_alpha',0]],10], true);
	_level0.i_eventQueue.addEvent (_root.i_scr_intro, 'removeMovieClip', null, false);
	_root.buildXML ('auctions_quizdata_es','quizdata');
}

endGame = function () {
	getURL ('javascript:window.close ();');
	fscommand ('quit');
}

showOgolPage = function (l) {
	if (l == 'es') {
		getURL ("http://alertaenlinea.gov/shopping_es.html", "_blank");
	} else {
		getURL ("http://onguardonline.gov/shopping.html", "_blank");
	}
}

replayGame = function () {
	_root.firstPlay = false;
	_root.playerScore = 0;
	_root.currentPointValue = 0;
	_root.currentQuestionIsDare = false;
	_root.extendedPlay = false;
	_root.checkExtend = true;
	_root.questionsPlayed = 0;
	startGame ();
}

attachNewMc = function (mc, libname,instname) {
	if (libname != null) {
		mc.attachMovie (libname, instname, newMCDepth () );
	} else {
		mc.createEmptyMovieClip (instname, newMcDepth () );
	}
	_root.attachedMcs.push (_root[instname]);
}

startSoundtrack = function () {
	for (var i in _root.soundList) {
		if (!_root.soundList[i].playing && _root.soundList[i].ambient) {
			_root.soundList[i].start (0,1000);
			_root.soundList[i].playing = true;
		}
	}
	_root.soundPlaying = true;
}

stopSoundtrack = function () {
	for (var i in _root.soundList) {
		_root.soundList[i].stop ();
		_root.soundList[i].playing = false;
	}
	_root.soundPlaying = false;
}

toggleSound = function () {
	if (_root.soundPlaying) {
		_root.stopSoundtrack ();
	} else {
		_root.startSoundtrack ();
	}
}

buildXML = function (a,name) {	// create XML object from file
	_root[name] = new XML ();
	_root[name].ignoreWhite = true;
	_root[name].onLoad = _root.xmlloadingDone;
	_root[name].load (a + '.xml');
}

xmlLoadingDone = function (b) {
//	drawTestAnswer ();
//	showQuestion (1);
	initMovie ();
}

bdboxClicked = function (box) {
	box.kill ();
	if (box.isDare) {
		if (_root.playerScore > 0) {
			_root.currentQuestionIsDare = true;
			_root.showDareScreen (box);
			return;
		} else if (_root.questionsPlayed < _root.i_bdboxCarrier.boxMcs.length - 1) {
			_root.assignDareBox ();
		}
	}
	_root.currentQuestionIsDare = false;
	_root.showQuestionBg (box);
	_level0.i_eventQueue.addEvent (_root, 'showQuestion', box, false);
}

showDareScreen = function (box) {
	_root.attachNewMc (_root, 'm_scr_dare', 'i_scr_dare');
	_root.i_scr_dare._alpha = 0;
	_root.i_scr_dare.moveToA (_root.quboxPos);
	_root.i_scr_dare.i_warningText.hide ();
	_root.i_scr_dare.i_dareAmount.maxChars = 4;
	_root.i_scr_dare.i_dareAmount.restrict = '0-9';
	_root.i_scr_dare.i_dareAmount.text = _root.playerScore;

	_root.i_scr_dare.i_dareAmount.onChanged = function () { _root.i_scr_dare.i_warningText.hide (); }

	_root.attachNewMc (_root.i_scr_dare, 'm_smallbtn', 'i_btnContinue');
	_root.i_scr_dare.i_btnContinue.moveToA ([322,264]);

	_root.i_scr_dare.i_btnContinue.bgColors = _root.darebtnBgColors;
	_root.i_scr_dare.i_btnContinue.olColors = _root.darebtnOlColors;
	_root.i_scr_dare.i_btnContinue.textColors = _root.darebtnTextColors;
	_root.i_scr_dare.i_btnContinue.onRelease = function () { _root.dareButtonClicked (box); }

	_level0.i_eventQueue.addEvent (_root.i_bdBoxCarrier, 'dimBoxes', null, false);
	_level0.i_eventQueue.addEvent (_root.i_scr_dare, 'tweenTo', [[['_alpha', 100]], 5], false);
	_level0.i_eventQueue.addEvent (_root.sound_banjodouble, 'start', null, false);
	Selection.setFocus (_root.i_scr_dare.i_dareAmount);
}

dareButtonClicked = function (box) {
	// wager allowed?
	if (parseInt (_root.i_scr_dare.i_dareAmount.text) <= _root.playerScore && parseInt (_root.i_scr_dare.i_dareAmount.text) >= 0) {
		// yes - adjust pointValue, dismiss screens
		_root.currentPointValue = parseInt (_root.i_scr_dare.i_dareAmount.text);
		_root.i_scr_dare.removeMovieClip ();
		trace (_root.currentPointValue);
		_root.showQuestionBg (box);
		_level0.i_eventQueue.addEvent (_root, 'showQuestion', box, false);
	} else {
		_level0.i_eventQueue.addEvent (_root.sound_incorrect, 'start', null, false);
		_root.i_scr_dare.i_warningText.show ();
		_root.i_scr_dare.i_dareAmount.text = _root.playerScore;
		Selection.setFocus (_root.i_scr_dare.i_dareAmount);
	}
}

assignDareBox = function () {
	var rand = Math.floor (Math.random () * _root.i_bdboxCarrier.boxMcs.length);
	if (_root.i_bdboxCarrier.boxMcs[rand].isDare || !_root.i_bdboxCarrier.boxMcs[rand].alive) {
		assignDareBox ();
	} else {
		_root.i_bdboxCarrier.boxMcs[rand].isDare = true;
		trace (_root.i_bdboxCarrier.boxMcs[rand]._name);
	}
}

answerboxClicked = function (box) {
	for (var i in _root.i_qubox.answerMcs) {
		_root.i_qubox.answerMcs[i].kill ();
	}
	_root.i_qubox.i_explanationText.htmlText = box.explanationText;
	_root.i_qubox.i_explanationText.hide ();
//	_root.i_qubox._visible = true;
	if (box.correct) {
		if (_root.currentQuestionIsDare) {
//			_level0.i_eventQueue.addEvent (_root.sound_applause, 'start', null, false);
			_level0.i_eventQueue.addEvent (_root.sound_banjocorrect, 'start', null, false);
		} else {
			_level0.i_eventQueue.addEvent (_root.sound_correct, 'start', null, false);
		}
		_root.i_qubox.i_explanationText.setTextFormat (_root.explanationCorrectTf);
		_root.playerScore += parseInt (_root.currentPointValue);
	} else {
		if (_root.currentQuestionIsDare) {
//			_level0.i_eventQueue.addEvent (_root.sound_awww, 'start', null, false);
			_level0.i_eventQueue.addEvent (_root.sound_banjoincorrect, 'start', null, false);
		} else {
			_level0.i_eventQueue.addEvent (_root.sound_incorrect, 'start', null, false);
		}
		_root.i_qubox.i_explanationText.setTextFormat (_root.explanationIncorrectTf);
		if (_root.currentQuestionIsDare || _root.extendedPlay) {
			_root.playerScore -= parseInt (_root.currentPointValue);
		}
	}
	_root.questionsPlayed ++;
	_level0.i_eventQueue.addWait (10);
	_level0.i_eventQueue.addEvent (_root.i_qubox.i_explanationText, 'show', null, false);
	_level0.i_eventQueue.addWait (10);
	_level0.i_eventQueue.addEvent (_root.i_qubox.i_buttonContinue, 'show', null, false);
	_level0.i_eventQueue.addEvent (_root, 'updateScoreDisplay', null, false);
}

updateScoreDisplay = function () {
	if (parseInt (_root.i_score.i_scoreText.text) != _root.playerScore) {
		_root.i_score.i_scoreText.text = _root.playerScore;
		_root.i_score.i_scoreText.setTextFormat (_root.scoreTextTf);
		for (var i = 0; i < 4; i++) {
			_level0.i_eventQueue.addEvent (_root.i_score.i_scoreText, 'hide', null, false);
			_level0.i_eventQueue.addWait (3);
			_level0.i_eventQueue.addEvent (_root.i_score.i_scoreText, 'show', null, false);
			_level0.i_eventQueue.addWait (3);
		}
	}
}

showQuestionBg = function (box) {
	var startPt = [box._x + box._width/2, box._y + box._height/2];
	_root.i_qubox.i_text.htmlText = '';
	_root.i_qubox.movetoA (startPt);
	_root.i_qubox._xscale = 10;
	_root.i_qubox._yscale = 10;
	_root.i_qubox._alpha = 0;
	_root.i_qubox._visible = true;

	var tweenArray = [];
	tweenArray.push (['_x',_root.quboxPos[0]]);
	tweenArray.push (['_y',_root.quboxPos[1]]);
	tweenArray.push (['_xscale',100]);
	tweenArray.push (['_yscale',100]);
	tweenArray.push (['_alpha',100]);

	_level0.i_eventQueue.addEvent (_root.i_bdBoxCarrier, 'dimBoxes', null, false);
	_level0.i_eventQueue.addEvent (_root.i_qubox, 'tweenTo', [tweenArray, 10], true);
}

endQuestion = function () { //bool
	_level0.i_eventQueue.addEvent (_root.i_qubox, 'tweenTo', [[['_alpha',0]], 10], true);
	for (var i in _root.i_qubox.answerMcs) {
		_root.i_qubox.answerMcs[i].removeMovieClip ();
	}
	_root.i_qubox.i_questionText.htmlText = '';
	_root.i_qubox.i_explanationText.htmlText = '';
	_root.i_qubox.i_buttonContinue.hide ();
	_level0.i_eventQueue.addEvent (_root.i_qubox, 'hide', null, false);
	if (_root.questionsPlayed < _root.i_bdboxCarrier.boxMcs.length) {
		if (!extendedPlay && _root.playerScore >= _root.winningScore) {
			_root.showExtendScreen ();
		} else {
			_level0.i_eventQueue.addEvent (_root.i_bdBoxCarrier, 'lightBoxes', null, false);
		}
	} else {
		_root.showEnding ();
	}
}

continueButtonClicked = function () {
	_root.endQuestion (_root.extendedPlay);
}

showExtendScreen = function () {
	_root.i_qubox.hide ();
	_root.attachNewMc (_root, 'm_scr_extend', 'i_scr_extend');
	_root.i_scr_extend._alpha = 0;

	_root.attachNewMc (_root.i_scr_extend, 'm_btnExtend', 'i_btnExtend');
	_root.i_scr_extend.i_btnExtend.moveToA ([85,300]);

	_root.i_scr_extend.i_btnExtend.bgColors = _root.extendbtnBgColors;
	_root.i_scr_extend.i_btnExtend.olColors = _root.extendbtnOlColors;
	_root.i_scr_extend.i_btnExtend.textColors = _root.extendbtnTextColors;
	_root.i_scr_extend.i_btnExtend.onRelease = function () { _root.extendButtonClicked (box); }
	
	_root.attachNewMc (_root.i_scr_extend, 'm_btnStop', 'i_btnStop');
	_root.i_scr_extend.i_btnStop.moveToA ([85,360]);

	_root.i_scr_extend.i_btnStop.bgColors = _root.extendbtnBgColors;
	_root.i_scr_extend.i_btnStop.olColors = _root.extendbtnOlColors;
	_root.i_scr_extend.i_btnStop.textColors = _root.extendbtnTextColors;
	_root.i_scr_extend.i_btnStop.onRelease = function () { _root.stopButtonClicked (box); }
	
	_level0.i_eventQueue.addEvent (_root.sound_banjodouble, 'start', null, false);
	_level0.i_eventQueue.addEvent (_root.i_scr_extend, 'tweenTo', [[['_alpha',100]],10], true);
}

extendButtonClicked = function () {
	_root.extendedPlay = true;
	_level0.i_eventQueue.addEvent (_root.i_scr_extend, 'tweenTo', [[['_alpha',0]],10], true);
	_level0.i_eventQueue.addEvent (_root.i_scr_extend, 'removeMovieClip', null, false);
//	_root.endQuestion ();
	_level0.i_eventQueue.addEvent (_root.i_bdBoxCarrier, 'lightBoxes', null, false);
}

stopButtonClicked = function () {
	_level0.i_eventQueue.addEvent (_root.i_scr_extend, 'tweenTo', [[['_alpha',0]],10], true);
	_level0.i_eventQueue.addEvent (_root.i_scr_extend, 'removeMovieClip', null, false);
	_root.showEnding ();
}

showQuestion = function (box) {

	var row = box._name.substr(-1,1);
	var col = box._name.substr(-2,1);
	
	var qNode = _root.quizdata.firstChild.childNodes[col].childNodes[row];
	_root.currentPointValue = (_root.currentQuestionIsDare) ? _root.currentPointValue : qNode.attributes.pointValue;
	var questionType = qNode.attributes.questionType;
	var ySpace = (questionType == 'boolean') ? _root.answerBoxYSpacing * 1.5 : _root.answerBoxYSpacing;
	
	var qText = qNode.firstChild.firstChild.nodeValue;
	
	_root.i_qubox.i_questionText.htmlText = qText;
	_root.i_qubox.i_questionText.setTextFormat (_root.questionTf);
	_root.i_qubox.i_questionText._height = _root.i_qubox.i_questionText.textHeight + 6;
	var yCursor = _root.i_qubox.i_questionText._y + _root.i_qubox.i_questionText._height + ySpace;
	
	_level0.i_eventQueue.addEvent (_root.sound_question, 'start', null, false);
	_level0.i_eventQueue.addWait (10);
	
	for (var i = 0; i < qNode.childNodes[1].childNodes.length; i ++) {
		var ansText = qNode.childNodes[1].childNodes[i].firstChild.firstChild.nodeValue;
		var explText = qNode.childNodes[1].childNodes[i].childNodes[1].firstChild.nodeValue;
		var ansCorrect = qNode.childNodes[1].childNodes[i].attributes.correct;

		attachNewMc (_root.i_qubox, 'm_ansbox', 'i_ansbox'+i);
		var o = _root.i_qubox['i_ansbox'+i];
		_root.i_qubox.answerMcs.push (o);
		o.propOnRelease = _root.answerBoxClicked;
		o.bgColors = _root.ansboxBgColors;
		o.olColors = _root.ansboxOlColors;
		if (questionType == 'boolean') {
			o.textFormat = _root.ansboxBoolTf;
		} else {
			o.textFormat = _root.ansboxTf;
		}
		o.textColors = _root.ansboxTextColors;
		o.textPadding = _root.answerTextPadding;
		o.correct = (ansCorrect == "true") ? true : false;
		o.answerText = ansText;
		o.explanationText = explText;
		o._x = _root.answerBoxIndent;
		o._y = yCursor;
		yCursor += o._height + ySpace;
		o._alpha = 0;
		_level0.i_eventQueue.addEvent (o, 'tweenTo', [[['_alpha', 100]], 3], true);
	}
	
	_root.i_qubox.i_explanationText._y = yCursor;
	yCursor += _root.i_qubox.i_explanationText._height + ySpace;
}

showEnding = function () {
	if (_root.playerScore >= _root.winningScore) {
		if (_root.extendedPlay) {
			var libAsset = 'm_scr_endingWinExtended';
		} else {
			var libAsset = 'm_scr_endingWin';
		}
	} else {
		var libAsset = 'm_scr_endingLose';
	}
	_root.attachNewMc (_root, libAsset, 'i_scr_ending');
	_root.i_scr_ending._alpha = 0;

	_root.attachNewMc (_root.i_scr_ending, 'm_btnReplay', 'i_btnReplay');
	_root.i_scr_ending.i_btnReplay.moveToA ([425,445]);
	_root.i_scr_ending.i_btnReplay.bgColors = _root.barbtnBgColors;
	_root.i_scr_ending.i_btnReplay.olColors = _root.barbtnOlColors;
	_root.i_scr_ending.i_btnReplay.textColors = _root.barbtnTextColors;
	_root.i_scr_ending.i_btnReplay.onRelease = function () { _root.replayGame (); }

	_root.attachNewMc (_root.i_scr_ending, 'm_btnClose', 'i_btnClose');
	_root.i_scr_ending.i_btnClose.moveToA ([507,445]);
	_root.i_scr_ending.i_btnClose.bgColors = _root.barbtnBgColors;
	_root.i_scr_ending.i_btnClose.olColors = _root.barbtnOlColors;
	_root.i_scr_ending.i_btnClose.textColors = _root.barbtnTextColors;
	_root.i_scr_ending.i_btnClose.onRelease = function () { _root.endGame (); }

	_root.i_scr_ending._visible = true;
	_level0.i_eventQueue.addEvent (_root.sound_ending, 'start', null, false);
	_level0.i_eventQueue.addEvent (_root.i_scr_ending, 'tweenTo', [[['_alpha',100]],10], true);
}

/* ---------------- MOVIE INITIALIZATION ------------------- */

initMovie = function () {
	_root.i_breaker.removeMovieClip ();
	

/*
	if (_root.restartSoundOnReplay) {
		_root.startSoundtrack ();
	}

	_root.attachNewMc ('m_b_sound', 'i_buttonSound');
	_root.i_buttonSound.moveToA ([600,445]);
	_root.i_buttonSound.gotoAndStop (_root.soundPlaying ? 1 : 3);
	_root.i_buttonSound.onRelease = function () {
		if (!_global.jdgButtonHold && !this.buttonHold) {
			_root.toggleSound ();
			this.gotoAndStop (_root.soundPlaying ? 1 : 3);
		}
	}
	_root.i_buttonSound.onRollOver = function () {
		if (!_global.jdgButtonHold && !this.buttonHold) {
			this.gotoAndStop (_root.soundPlaying ? 2 : 4);
		}
	}
	_root.i_buttonSound.onRollOut = function () {
		if (!_global.jdgButtonHold && !this.buttonHold) {
			this.gotoAndStop (_root.soundPlaying ? 1 : 3);
		}
	}
*/


	// draw game board
	

	attachNewMc (_root, null,'i_bdboxCarrier');
	
	_root.i_bdboxCarrier.boxMcs = [];
	_root.i_bdboxCarrier.catLabelTfs = [];

	for (var i = 0; i < 4; i++) {

		_root.i_bdBoxCarrier.createTextField ('i_catLabel'+i, newMCDepth(), _root.boxStart[0] + (_root.boxSpacing[0] * i), _root.catLabelY, 130, 40);
		var p = _root.i_bdBoxCarrier['i_catLabel'+i];
		p.multiline = true;
		p.wordWrap = true;
		p.embedFonts = true;
		p.selectable = false;
		p.html = false;
		p.setNewTextFormat (_root.categoryTf);
		p.text = _root.quizdata.firstChild.childNodes[i].attributes.catname;
		p.setTextFormat (_root.categoryTf);
		_root.i_bdboxCarrier.catLabelTfs.push (p);
		p.hide ();

		for (var j = 0; j < 3; j++) {
			attachNewMc (_root.i_bdboxCarrier, 'm_bdbox', 'i_bdbox' + i + j);
			var o = _root.i_bdboxCarrier['i_bdbox' + i + j];
			o.pointval = _root.pointbase * (j + 1);
			o.bgColors = _root.bdboxBgColors;
			o.olColors = _root.bdboxOlColors;
			o._x = _root.boxStart[0] + (_root.boxSpacing[0] * i);
			o._y = _root.boxStart[1] + (_root.boxSpacing[1] * j);
			o.propOnRelease = _root.bdboxClicked;
			_root.i_bdboxCarrier.boxMcs.push (o);
			o.hide ();
		}
	}
	
	_root.assignDareBox ();
	
	// light category labels
	_level0.i_eventQueue.addEvent (_root.sound_question, 'start', null, false);
	for (var i in _root.i_bdboxCarrier.catLabelTfs) {
		_level0.i_eventQueue.addEvent (_root.i_bdboxCarrier.catLabelTfs[i], 'show', null, false);
	}
	_level0.i_eventQueue.addWait (18);
	
	
	// light boxes in random order
	var randomBdboxArray = returnRandomArray (_root.i_bdboxCarrier.boxMcs);
	for (var i in randomBdboxArray) {
		var s = 3 - (i % 3);
		_level0.i_eventQueue.addEvent (_root['sound_blip' + s], 'start', null, false);
		_level0.i_eventQueue.addEvent (randomBdboxArray[i], 'show', null, false);
		_level0.i_eventQueue.addWait (3);
	}

	// set up score box
	
	_root.attachNewMc (_root, null, 'i_score');
	
	_root.attachNewMc (_root.i_score, 'm_rect', 'i_scoreBg');
	_root.i_score.i_scoreBg._width = 129;
	_root.i_score.i_scoreBg._height = 30;
	_root.tmpColor = new Color (_root.i_score.i_scoreBg);
	_root.tmpColor.setRGB (0x0054a5);
	delete (_root.tmpColor);
	_root.i_score.i_scoreBg.moveToA ([467,395]);

	_root.i_score.createTextField ('i_scoreLabel', newMCDepth(), 0, 400, 459, 24);
	_root.i_score.i_scoreLabel.multiline = false;
	_root.i_score.i_scoreLabel.wordWrap = false;
	_root.i_score.i_scoreLabel.embedFonts = true;
	_root.i_score.i_scoreLabel.selectable = false;
	_root.i_score.i_scoreLabel.html = false;
	_root.i_score.i_scoreLabel.text = 'Puntos';
	_root.i_score.i_scoreLabel.setTextFormat (_root.scoreLabelTf);

	_root.i_score.createTextField ('i_scoreText', newMCDepth(), 469, 395, 129, 60);
	_root.i_score.i_scoreText.multiline = false;
	_root.i_score.i_scoreText.wordWrap = false;
	_root.i_score.i_scoreText.embedFonts = true;
	_root.i_score.i_scoreText.selectable = false;
	_root.i_score.i_scoreText.html = false;
	_root.i_score.i_scoreText.text = '0';
	_root.i_score.i_scoreText.setTextFormat (_root.scoreTextTf);
	
	// set up question box
	
	_root.attachNewMc (_root, 'm_qubox', 'i_qubox');
	_root.i_qubox._visible = false;
	_root.i_qubox.answerMcs = [];
	
	_root.attachNewMc (_root.i_qubox, 'm_smallbtn', 'i_buttonContinue');
	_root.i_qubox.i_buttonContinue.moveToA (_root.continueButtonPos);
//	_root.i_qubox.i_buttonContinue.__proto__ = Buttonbox.prototype;
	_root.i_qubox.i_buttonContinue.bgColors = _root.contbtnBgColors;
	_root.i_qubox.i_buttonContinue.olColors = _root.contbtnOlColors;
	_root.i_qubox.i_buttonContinue.textColors = _root.contbtnTextColors;
	_root.i_qubox.i_buttonContinue.hide ();
	_root.i_qubox.i_buttonContinue.onRelease = function () { _root.continueButtonClicked (); }

	_root.i_qubox.createTextField ('i_questionText', 1, _root.questionTextPadding, _root.questionTextPadding * .6, _root.i_qubox._width - (_root.questionTextPadding * 2), _root.i_qubox._height * 4);
	var o = _root.i_qubox.i_questionText;
	o.multiline = true;
	o.wordWrap = true;
	o.embedFonts = true;
	o.selectable = false;
	o.html = true;
	o.setNewTextFormat (_root.questionTf);
	
	_root.i_qubox.createTextField ('i_explanationText', 2, _root.questionTextPadding, 480, _root.i_qubox._width - (_root.questionTextPadding * 2), _root.i_qubox._height * 4);
	var p = _root.i_qubox.i_explanationText;
	p.multiline = true;
	p.wordWrap = true;
	p.embedFonts = true;
	p.selectable = false;
	p.html = true;
	p.setNewTextFormat (_root.explanationIncorrectTf);
	p._visible = false;
	
	_root.i_bdboxCarrier.dimBoxes = function () {
		for (var i in _root.i_bdboxCarrier.boxMcs) {
			_root.i_bdboxCarrier.boxMcs[i].deactivate ();
		}
		_root.i_bdboxCarrier.tweenTo ([[['_alpha', 50]], 10]);
	}
	
	_root.i_bdboxCarrier.lightBoxes = function () {
		for (var i in _root.i_bdboxCarrier.boxMcs) {
			_root.i_bdboxCarrier.boxMcs[i].activate ();
		}
		_root.i_bdboxCarrier.tweenTo ([[['_alpha', 100]], 10]);
	}

}


/* ---------------- RUNTIME ------------------- */



if (_root == _level0) { startGame (); }
